//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef INST_EXP_VISITOR_HH
# define INST_EXP_VISITOR_HH

# include "misc/select_const.hh"

# include "inst/fwd.hh"

namespace inst
{

  template <typename K>
  class GenExpVisitor
  {
  public:
    virtual ~GenExpVisitor()
    {
    }

  public:
    virtual void visit(typename select_const<K, IntExp>::type&) = 0;
    virtual void visit(typename select_const<K, LabelExp>::type&) = 0;
    virtual void visit(typename select_const<K, OpExp>::type&) = 0;
  };

  typedef GenExpVisitor<const_kind> ConstExpVisitor;
  typedef GenExpVisitor<non_const_kind> ExpVisitor;

} // namespace inst

#endif // !INST_EXP_VISITOR_HH
