//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef INST_OP_EXP_HH
# define INST_OP_EXP_HH

# include <ostream>

# include "inst/exp.hh"

namespace inst
{

  class OpExp:
    public Exp
  {
  public:
    enum kind_type { add, sub, mul, div };

  public:
    OpExp(const CountedExp &left, kind_type kind, const CountedExp &right);
    virtual ~OpExp();

  public:
    virtual void accept(ConstExpVisitor &v) const;
    virtual void accept(ExpVisitor &v);

  public:
    const Exp &get_left() const;
    Exp &get_left();

    const Exp &get_right() const;
    Exp &get_right();

  public:
    virtual void write(std::ostream &ostr) const;

  public:
    const kind_type kind_;

  protected:
    CountedExp left_;
    CountedExp right_;
  };

} // namespace inst

# include "inst/op_exp.hxx"

#endif // !INST_OP_EXP_HH
