//
// lexutils.hh: utilities for lexical analysis
// Copyright (C) 2005 Benoit Perrot <benoit@lrde.epita.fr>
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// It is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef MISC_LEXUTILS_HH
# define MISC_LEXUTILS_HH

# include <cctype>

# include "config.h"

#ifndef HAVE_ISBLANK
inline bool
isblank(int c)
{
  return c == ' ' || c == '\t';
}
#endif // !HAVE_ISBLANK


class istringstream;

namespace misc
{

  /// Skip blank characters
  std::istringstream &
  skip_blank(std::istringstream &iss);

} // namespace misc

#endif // !MISC_LEXUTILS_HH
