//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef PARSE_PARSE_TASKS_HH
# define PARSE_PARSE_TASKS_HH

# include "task/libtask.hh"

namespace inst { class Program; }

namespace parse
{

  namespace tasks
  {
    extern inst::Program*	program;

    TASK_MODULE ("1. Parsing");

    TASK_DECLARE ("trace-scan", "Trace the scanning",
		  trace_scan, "");
    TASK_DECLARE ("u|unlimited-regs", "Authorize unlimited registers",
		  unlimited_regs, "");

    TASK_DECLARE ("trace-parse", "Trace the parse",
		  trace_parse, "");
    TASK_DECLARE ("N|nop-after-branch", 
		  "Fill delay slot of branch instructions with a NOP",
		  nop_after_branch, "");
    TASK_DECLARE ("parse", "Parse a file",
		  parse, "");

  } // namespace tasks

} // namespace parse

#endif // !!PARSE_PARSE_TASKS_HH
