//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef PARSE_ASM_SCAN_HH
# define PARSE_ASM_SCAN_HH

# include "parse/asm-parse.hh"

# define YY_DECL \
  int yylex (yy::parser::semantic_type *yylval, \
	     yy::parser::location_type *yylloc)
YY_DECL;

namespace parse
{
  /** \brief Open the scanner step. */
  void scan_open(const std::string &filename, bool trace_p);

  /** \brief Close the scanner step. */
  void scan_close(void);
}

#endif // !PARSE_ASM_SCAN_HH
