//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004 Akim Demaille <akim@epita.fr> and
//		      Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#include "task/function_task.hh"

namespace task
{

  FunctionTask::FunctionTask(void (*execute) (void),
			     const std::string& option,
			     const std::string& module_name,
			     const std::string& desc,
			     const std::string& deps):
    Task(option, module_name, desc, deps),
    execute_(execute)
  {}

  void
  FunctionTask::execute() const
  {
    execute_();
  }

} // namespace task
