//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2005 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
#ifndef VM_VM_TASKS_HH
# define VM_VM_TASKS_HH

# include "task/libtask.hh"

namespace vm
{

  namespace tasks
  {

    TASK_MODULE ("3. Virtual Machine");

    BOOLEAN_TASK_DECLARE ("check-callee-save",
			  "Warn if a callee save register "
			  "is not preserved across a call",
			  check_callee_save_p, "");

    BOOLEAN_TASK_DECLARE ("profile", "Enable program profiling",
			  profile_p, "");

    STRING_TASK_DECLARE ("l|system-library", 
			 "\n"
			 "\t\t\tSpecify the builtin system library to use;\n"
			 "\t\t\tvalid library names are: `spim' (default), "
			 "`nolimips', \n"
			 "\t\t\tand `none'\n",
			 select_system_library, "spim",
			 "");
    
    BOOLEAN_TASK_DECLARE ("E|trace-exec", "Trace the execution",
			  trace_exec_p, "");
    TASK_DECLARE ("e|execute", "Execute the program on virtual machine",
		  execute, "prg-solve");


  } // namespace tasks

} // namespace vm

#endif // !VM_VM_TASKS_HH
